function disableObjectWeight(disable) {
    if (disable) {
        $('#objectWeight').addClass('disabled');
        $('#objectWeightUnit').addClass('disabled');
        $('#objectWeightUnit').prop('disabled', true);
    } else {
        $('#objectWeight').removeClass('disabled');
        $('#objectWeightUnit').removeClass('disabled');
        $('#objectWeightUnit').prop('disabled', false);
    }
}

function createCostDataCommonHTML(){
    document.write("<div id='objectMessage'></div>");
    var headers = {
        code: l10n("Code"),
        desc: l10n("Description"),
        input: l10n("Input"),
        factor: l10n("Factor"),
        unit: l10n("Unit"),
        cost: l10n("Unit Cost"),
        waste: l10n("Waste%"),
        tax: l10n("Tax%")
    };
    document.write("<div id='lineItemsWrapper'><table id='lineItems'><thead><tr><th class='localize'>" + headers.code + "</th><th class='localize'>" + headers.desc + "</th><th class='localize'>" + headers.input + "</th><th class='localize'>" + headers.factor + "</th><th class='localize'>" + headers.unit + "</th><th class='localize'>" + headers.cost + "</th><th class='localize'>" + headers.waste + "</th><th class='localize'>" + headers.tax + "</th><th>&nbsp;</th></tr></thead><tbody></tbody></table></div>");
    document.write("<div id='closeButtonWrapper'><input type='button' value='" + l10n("OK") + "' class='button apply-cancel localize' id='closeButton' onclick='tellSU(this);'></div>");
    document.write("<div id='closeButtonWrapper' style='visibility: hidden; position: static;'><input type='button' class='button apply-cancel localize'></div>");
}

function createCostDataCommonButtons(){
    document.write("<td class='right'>");
    document.write("<input type='image' class='smallbutton' id='copyButton' title='" + l10n("Copy cost data lines to clipboard") + "' src='images/copy.svg' onclick='tellSU(this);'>");
    document.write("<input type='image' class='smallbutton' id='pasteButton' title='" + l10n("Paste cost data lines from clipboard") + "' src='images/paste.svg' onclick='tellSU(this);'>");
    document.write("<input type='image' class='smallbutton' id='newLineButton' title='" + l10n("Add cost item") + "' src='images/plus.png' onclick='tellSU(this);'>");
    document.write("</td>");

}

function hideCostDataTable(){
    $('#lineItems').hide();
}


function showCostDataTable(){
    $('#lineItems').show();
}