// Each plugin using this module should define js/main.js that it must include these methods at minimum
function tellSU(element)
{
    id = element.id;
    window.location = 'skp:ValueChanged@' + id;
}

function l10n(string) {
    var result = l10n_strings[string];
    if (result === undefined) {
        return string;
    } else {
        return result;
    }
}

function localize(strings) {
    l10n_strings = strings;
    $(".localize").each(function() {
        var $this = $(this);
        var type = $this.prop('tagName').toLowerCase();
        var input, output = '';

        switch(type) {

            case "input":
                input = $this.attr("placeholder");
                output = l10n(input);
                $this.attr("placeholder", output);
                break;

            default:
                input = $this.text();
                output = l10n(input);
                $this.text(output);
        }

    });
}

function disableContextMenu() {
    $(document).on('contextmenu', function(e) {
        return $(e.target).is('input[type=text]');
    });
}

disableContextMenu();